{
  Program Ranking for mines
  Author: Marcelo Teixeira Silveira
  Web site: http://www.eng,uerj.br/~marcelo/msx
}
const rankFile = 'minerank.dat';

Type rank = record
              name : string[80];
              time : integer;
            end;
     TName = string[80];

var ranking : array[1..20] of rank;
	rankDisk : file of rank;
succ : boolean;

procedure moveElements(pos : integer);
var i, offset : integer;
begin
  offset:=1;
  { Change if # of games change }
  if pos > 10 then
    offset:=11;
  for i:=offset+9 downto pos+1 do
  begin    
    ranking[i].name:=ranking[i-1].name;
    ranking[i].time:=ranking[i-1].time;
  end;
end;

function isNewRecord(tm, mode : integer) : boolean;
var i : integer;
    offset : integer;
begin
  isNewRecord:=true;
  offset:=1;
  if (mode<>1) then
    offset:=11;

  for i:=offset to offset+9 do
  begin
    if (tm<=ranking[i].time) or (ranking[i].time=-1) then
      exit;
  end;
  isNewRecord:=false;
end;

procedure insertNew(nm : TName; tm, mode : integer);
var i : integer;
    offset : integer;
begin
  offset:=1;
  if (mode<>1) then
    offset:=11;

  for i:=offset to offset+9 do
  begin
    { It finds an empty position, then exit }
    if (ranking[i].time=-1) then
    begin
      ranking[i].name:=nm;
      ranking[i].time:=tm;
      exit;
    end;
    { Compare with current position }
    if (tm<=ranking[i].time) then
    begin
       moveElements(i);
       ranking[i].name:=nm;
       ranking[i].time:=tm;
       exit;
    end;
  end;
end;
 
procedure readRanking;
var i : integer;
begin
  Assign(rankDisk,rankFile);
  Reset(rankDisk);
  for i:=1 to 20 do
    Read(rankDisk,ranking[i]);
  close(rankDisk);
end;


{retirado do manual da RTL - Wikipedia.org - Works on MSX ;)}
function FileExists(Name : TName) : boolean;
Var
  F : File;
begin
  {$I-}
  Assign (F,Name);
  Reset (F);
  {$I+}
  FileExists:=(IoResult=0) and (Name<>'');
  Close (F); 
end;
 
procedure saveRanking;
var i : integer;
begin
  writeln('Writing ranking to disk ...');
  Assign(rankDisk,rankFile);
  Rewrite(rankDisk);

  for i:=1 to 20 do
    Write(rankDisk,ranking[i]);
  close(rankDisk);
end;

procedure printDosRanking(mode : integer);
var i, offset : integer;
begin
  offset:=1;
  if (mode<>1) then
    offset:=11;

  writeln('Ranking easy');
  for i:=offset to offset+9 do
    writeln(i,'-',ranking[i].name,':',ranking[i].time);
end;

procedure clearRanking;
var i : integer;
begin
  for i:=0 to 20 do
  begin
    ranking[i].name:='';
    ranking[i].time:=-1;
  end;
end;

procedure initRanking;
begin
  if (FileExists(rankFile)) then
    readRanking
  else
    clearRanking;
end;
  
{ Use this code to test these routines }
{  
begin

  clearRanking;
  succ:=insertNew('Marcelo',20,1);
  succ:=insertNew('Guilherme',25,1);
  succ:=insertNew('Patricia',10,1);
  printDosRanking(1);
  saveRanking;

  readRanking;
  printDosRanking(1);

  if (FileExists(rankFile)) then writeln('Arquivo existe!') else writeln('arquivo nao existe');
  if (FileExists('abc.def')) then writeln('Arquivo existe!') else writeln('arquivo nao existe');

end.}